/*------------------------------------------
//            Karakterszamlalo
//                by -zolee-
//
//  Szamoljuk meg, hogy a billentyuzetrol
//  melyik karakterbol mennyi erkezett. A
//  0 darabszamu karaktereket ne jelenitsuk
//  meg
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>

enum {MAXHOSSZ = 126};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int i, vege=0, egyeb=0, kisbetu=0, nagybetu=0;
    int nagybetuk[26], kisbetuk[26];

    clrscr();

    for(i=0;i<26;i++) {
        nagybetuk[i] = 0;
        kisbetuk[i]  = 0;
    }

    printf("Kerem adjon meg egy maximum %d hosszu karaktersorozatot:\n"
           "---------------------------------------------------------\n", MAXHOSSZ);
    do {
        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp)>MAXHOSSZ)
            printf("Sajnalom de maximum %d karaktert adhat meg!\n", MAXHOSSZ);
        else {
            for (i=0; tmp[i]!='\0'; i++) {
                if (isupper(tmp[i])) {
                    nagybetuk[tmp[i]-'A']++;
                    nagybetu = 1;
                } else if (islower(tmp[i])) {
                    kisbetuk[tmp[i]-'a']++;
                    kisbetu = 1;
                } else
                    egyeb++;
            }
            vege=1;
        }
    } while (!vege);

    printf("\nA nagybetuk szama:\n"
           "------------------\n");
    if (nagybetu) {
        for (i=0; i<26; i++)
            if(nagybetuk[i]!=0)
                printf("'%c' karakterbol %d darab volt a bemeneten.\n", i+'A', nagybetuk[i]);
    } else {
        printf("A beirt szovegben nem szerepelt nagybetus karakter!\n");
    }

    printf("\nA kisbetuk szama:\n"
           "-----------------\n");
    if (kisbetu) {
        for(i=0; i<26; i++)
            if(kisbetuk[i]!=0)
                printf("'%c' karakterbol  %d darab volt a bementen.\n", i+'a', kisbetuk[i]);
    } else {
        printf("A beirt szovegben nem szerepelt kisbetus karakter!\n");
    }

    if (egyeb > 0)
        printf("\n%d egyeb karakter volt!\n", egyeb);
    else
        printf("\nA beirt szovegben nem szerepelt egyeb karakter!\n");

    getch();
}