/*------------------------------------------
//           Neptunkod generator
//                by -zolee-
//
//  Kockadobos jatek.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main (void) {
    char tmp[2+1];
    unsigned int i,eredmenyek[6],vege=0,jatekosdb,jatekos=0,maximum=0,elso,masodik,harmadik;

    clrscr();
    randomize();

    printf("             -- Kockadobos jatek --          \n"
           "Kerem adja meg jatekosok szamat (min 3 max 6):\n"
           "==============================================\n");
    do {
        if (!getline(tmp, 2))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 1)
            printf("Tul sok karakert adott meg!\n");
        else {
            if (!isdigit(tmp[0]))
                printf("Nem egesz szamot adott meg!\n");
            else {
                jatekosdb=atoi(tmp);
                if (jatekosdb < 3)
                    printf("Legalabb harom jatekos kell!\n");
                else if (jatekosdb > 6)
                    printf("Maximum hatan jatszhatnak!\n");
                else
                    vege=1;
            }
        }
    } while (!vege);

    for (jatekos=0; jatekos<jatekosdb; jatekos++) {
        elso     = rand()%6+1;
        masodik  = rand()%6+1;
        harmadik = rand()%6+1;
        eredmenyek[jatekos]=elso+masodik+harmadik;

        printf("A(z) %d. jatekos dobasai:\n"
               "========================\n"
               "Elso dobas         : %d\n"
               "Masodik dobas      : %d\n"
               "Harmadik dobas     : %d\n"
               "------------------------\n"
               "Osszeg: %d\n\n\n",jatekos + 1, elso, masodik, harmadik, eredmenyek[jatekos]);

        if(eredmenyek[jatekos] > maximum)
            maximum=eredmenyek[jatekos];
    }

    printf("A legnagyobb dobas %d volt.\n", maximum);
    getch ();
}