#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define MINSZ 15
#define MAXSZ 60
#define MAXH 128

#define ORA 19

#define HSZ sizeof(int)/sizeof(short)*5

int egesze(char s[])
{
  int i=0;
  int kezd;

  /* feher karakterek atlepese */
  while (s[i]==' ' || s[i]=='\n' || s[i]=='\t')
    i++;
  if (s[i]=='+' || s[i]=='-')
    i++;
  kezd=i;

  while (s[i]>='0' && s[i]<='9' && i-kezd<HSZ)
    ++i;

  if (s[i]!=0 && s[i]!='\n' && s[i]!='\t' && s[i]!=' ')
    return 0;
  else
    return 1;
}
int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void)
{
	int i=0, j=0, log, szamok[ORA], legertek1, legertek2, legindex1, legindex2, osszeg=0, x, zona1=0, zona2=0, zona3=0;
	char tmp[MAXH+1];
	float atlag;
	
	printf("A program egesz szamokat ker be max. %d db-ot. A szamok egy motor sebesseget\n"
		"rogzitik egy perces mintavetelezessel! Csak %d es %d kozotti szamokat adhat meg!\n"
		"A (%d adat) %d percet jelent. A program ures sorra befejezi a bekerest!\n"
		"--------------------------------------------------------------------------------\n\n", ORA+1, MINSZ, MAXSZ, ORA+1, ORA+1);
	
	log=0;
	while(!log)
	{
		printf("A(z) %d. adat: ", i+1);
		
		if(!getline(tmp,MAXH))/*Ha ures sor erkezik a program befejezi a bekerest!*/
		{
			printf("Ures sort adott meg! Vege a bekeresnek!\n");
			log=1;
		}
		else/*Ha nem ures sor erkezett ezzel az aggal megyunk tovabb!*/
		{
			if(egesze(tmp))/*Ha egesz a bevitt szam ezen az agon megyunk tovabb!*/
			{
				x=atoi(tmp);/*Az adott egesz szamot atalakitjuk int tipusura, hogy letudjuk tesztelni, hogy a megadott intervallumba tartozik e!*/
				
				if(x>=MINSZ && x<=MAXSZ)/*Ha beleesik az intervallumba*/
				{
					szamok[i]=x;/*Ha minden stimmel akkor a szamok tombbe letaroljuk, mivel i. elemrol van szo, majd azt i-t is noveltetni kell a megfelelo helyen*/
					i++;
					
					if(i==ORA+1)/*Ha i egyenlo lesz 20-al (ORA=19+1) kileptetjuk az egeszet a while ciklusbol, a cikluson kivul pedig elvegezzuk a szukseges muveleteket es egyeb feladatokat*/
						log=1;
					
				}
				else
					printf("Sajnalom, de csak %d es %d kozotti szamokat adhat meg!\n", MINSZ, MAXSZ);
			}
			else
				printf("Sajnalom, de csak egesz szamokat adhat meg!\n");
			
		}	
	}
	
	/*A fuggvennyel meghatarozzuk a legkisebb erteket es azt, hogy ez hanyadik elem volt a tombben*/
	legertek1=szamok[0];
	
	for(j=0;j<=i-1;j++)/*Vagy ez is lehetett volna:  	for(j=0;j<i;j++)	*/
	{

		if(szamok[j]<=legertek1)
		{
			legertek1=szamok[j];	
			legindex1=j;
		}
	}
	/*A fuggvennyel meghatarozzuk a legnagyobb erteket es azt, hogy ez hanyadik elem volt a tombben*/
	legertek2=szamok[0];
	
	for(j=0;j<=i-1;j++)/*Vagy ez is lehetett volna:  	for(j=0;j<i;j++)	*/
	{

		if(szamok[j]>=legertek2)
		{
			legertek2=szamok[j];	
			legindex2=j;
		}
	}
	for(j=0;j<80;j++)/*Ez csak disz! :D	*/
		printf("-");
	
	/*Minimum feladat*/
	printf("A legkisebb sebesseg: %d km/h, ami a tomb %d. eleme volt.\n"
		"A legnagyobb sebesseg: %d km/h, ", legertek1, legindex1+1, legertek2);
	
	j=legindex1-legindex2;/*Tehat ha kivonjuk a legkisebb elem helyebol a legnagyobb szam helyet megkapunk egy szamot amibol tudunk kovetkeztetni, hogy elotte vagy utan 
	szerepelt e a tomb elemei kozul, Az abs fuggveny azert kell, mert ha negativ szamot kapunk az megadja az abszoluterteket, de ehhez kell a MATH.H fejfajl!!!*/
	if(j<0)
	{
		j=abs(j);
		printf("ami %d perccel volt a legkisebb ertek utan.\n", j);
	}
	else
		printf("ami %d perccel volt a legkisebb ertek elott.\n", j);
	
	/*+1*/
	for(j=0;j<=i-1;j++)/*Osszeg meghatarozasa*/
		osszeg=osszeg+szamok[j];	/*Akar igy is meg lehetett volna csinalni: 	osszeg+=szamok[j];	*/
	
	atlag=(float)osszeg/i; 
	
		for(j=0;j<80;j++)/*Ez csak disz! :D	*/
			printf("-");
			
	printf("A sebessegek atlaga: %5.2f km/h\n"
		"Az atlag elterese a legkisebb ertektol: %5.2f\n"
		"Az atlag elterese a legnagyobb ertektol: %5.2f\n", atlag, atlag-legertek1, (float)legertek2-atlag);
	
	/*+1*/
		for(j=0;j<80;j++)/*Ez csak disz! :D	*/
			printf("-");
	
	
	if(legertek2==MAXSZ)
		printf("A legnagyobb sebesseg elerte a maximalis sebesseget (%d km/h-at)!\n", MAXSZ);
	else
	{
		j=MAXSZ-legertek2;
		printf("A legmagasabb sebesseg %d km/h-val alulmaradt a vegsebessegtol (%d km/h)!\n", j, MAXSZ);
	}
	
	/*+1*/
	for(j=0;j<=i-1;j++)/*Vagy ez is lehetett volna:  	for(j=0;j<i;j++)	*/
	{
		if(szamok[j]>=15 && szamok[j]<=30)
			zona1++;
		else if(szamok[j]>=31 && szamok[j]<=45)
			zona2++;
		else
			zona3++;
		
	}
	
		for(j=0;j<80;j++)/*Ez csak disz! :D	*/
			printf("-");
	
	printf("A sportolo zonakban tartozkodasa percben:\n"
		"Zona 1: 15 - 30: %d perc\n"
		"Zona 2: 31 - 45: %d perc\n"
		"Zona 3: 46 - 60: %d perc\n", zona1, zona2, zona3);
	
	getchar();/*Hogy ne szaladjon el a program, ha leforditjuk exe-be*/
	
}
