#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <limits.h>

#if SHRT_MAX == INT_MAX
	#define HOSSZ 4
#else
	#define HOSSZ 9
#endif						   /* Ennyi szmjegy biztosan elfr a trolsi formban.  */
#define F6 64
#define CTRLZ 26
#define MAX 128
#define SIZE 20
#define HATAR INT_MAX%10+'0'+1
#define HSZ sizeof(int)/sizeof(short)*5

int getline(char s[],int lim);
int egesze(char s[]);
int getint(int *pn);


void main(void)
{

int A[SIZE][SIZE],B[SIZE][SIZE];
int i,m=0,n=0,j;

system("cls");

printf("Mekkorak legyenek a matrixok?\n");

while (m<1 || m>SIZE){
printf("Sor:    ");
getint(&m);
if (m<1 || m>SIZE) printf("Nem megfelelo meret!\n");}

while (n<1 || n>SIZE){
printf("Oszlop: ");

getint(&n);
if (n<1 || n>SIZE) printf("Nem megfelelo meret!!\n\n");}

printf("Az A matrix feltoltese!!\n\n");
for (i=0;i<m;i++)
  for (j=0;j<n;j++){
    printf("[%d] [%d]: ",i+1,j+1);
    getint(&A[i][j]);}

printf("A B matrix feltoltese!!\n\n");
for (i=0;i<m;i++)
  for (j=0;j<n;j++){
    printf("[%d] [%d]: ",i+1,j+1);
    getint(&B[i][j]);}

printf("\nAz osszegmatrix:\n\n");

for (i=0;i<m;i++){
  for (j=0;j<n;
  )
    printf("%5d",A[i][j]+B[i][j++]);
  putchar(10);
  putchar(10);}

system("pause");
}


int getline(char s[],int lim)
{
  int i;
  char c;

  for (i=0;i<lim && (c=getchar())!=EOF && c!='\n';++i)
    s[i]=c;

  s[i]='\0';

  while (c!=EOF && c!='\n')
      c=getchar();
  return i;

}

int egesze(char s[])
{
  int i=0;
  int kezd;

  while (s[i]==' ' || s[i]=='\n' || s[i]=='\t')
    i++;
  if (s[i]=='+' || s[i]=='-')
    i++;
  kezd=i;

  while (s[i]>='0' && s[i]<='9' && i-kezd<HSZ)
    ++i;

  if (s[i]!=0 && s[i]!='\n' && s[i]!='\t' && s[i]!=' ')
    return 0;
  else
    return 1;
}

int getint(int *pn) /*Egsz beolvassa a bemenetrl gy,hogy az rvnytelen karakterek meg sem jelennek.*/
{
	int c;		    /* A beolvasott karakter. */
	int sign=1;     /* Eljel: pozitv +1, negatv -1. Alaprtelmezs a pozitv, a kezdrtk miatt. */
	int elojel=0;	/* Volt-e mr eljel? */
	int hossz=0;	/* A beolvasott szmjegy karakterek szma. */
	int null=0;		/* A beolvasott szm zrus-e? */
	while(hossz==0) switch(c=getch()) /* A getch() ltal a beolvasott karakter azonnal rendelkezsre */
	{								  /* ll, nincs pufferkezels soremels karakterig */
		case '+':
		case '-':	if (elojel==0)
					{
						putch(c);
						if (c=='+') sign=1;
						else sign=-1;
						++elojel;
					}
					break;
		case '0':	if (elojel==0)
					{
						putch(c);	/* A putch() kir egy karaktert kzvetlenl (pufferkezels nlkl)*/
						*pn=0;
						++hossz;
						null=1;
					}
					break;
		case '1': case '2': case '3':
		case '4': case '5': case '6':
		case '7': case '8': case '9':
					putch(c);
					*pn=c-'0';
					++hossz;
					break;
		default :	if (!c) c=getch();
					if (c==CTRLZ||c==F6) return EOF;
	}
	while(1) switch(c=getch())
	{
		case '\r':	if (c!='\r') putch(' ');
					else
					{
						putch('\n');
						putch('\r');
					}
					*pn= *pn * sign;
					return c;
		case '0': case '1': case '2':
		case '3': case '4': case '5':
		case '6': case '7': case '8':
		case '9':	if(!null && (hossz<HOSSZ||(hossz==HOSSZ&&(*pn<MAX||*pn==MAX&&(sign==1&&c<HATAR||sign==-1&&c<=HATAR)))))
					{
						putch(c);
						*pn= *pn * 10 + c - '0';
						++hossz;
					}
					break;
		default :	if (!c) c=getch();
					if(c==CTRLZ||c==F6)
					{
						*pn= *pn * sign;
						return EOF;
					}
	}
}



