/* 09_1.C: 11-nl kisebb alap szmok konverzija. Az alap fordtsi
		   idben vltoztathat. */

#define ALAP 10			/* A szmrendszer alapja. */
#define MAX 128			/* Input puffer mrete. */
#include <stdio.h>
#include <string.h>

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */

int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

/* Az s karakterlncot ALAP alap szmnak tekintve int-t konvertlja,
   s ez a rutin visszaadott rtke. */
int toi(char s[]){
	int i, eredmeny=0;

	for(i=0; s[i]!=0; ++i)
		eredmeny=eredmeny*ALAP+s[i]-'0';
	return eredmeny; }

/* "Az s karakterlnc ALAP alap szm-e?" krdsre ad logikai vlaszt
   a fggvny. */
int szame(char s[]){
	int i;

	/* Ha csak 10-es szmrendszert kellene vizsglni, a kifejezst */
	/* az isdigit() makrval lehetne egyszersteni.               */
	for(i=strlen(s)-1; i && s[i]>='0' && s[i]<ALAP+'0'; --i);
	if(s[i]>='0' && s[i]<ALAP+'0') return 1; else return 0; }

void main(void) {
	char szam[MAX+1];

	printf("\nAdja meg a %d szmrendszerbeli szmot!\n", ALAP);
	while(!getline(szam,ALAP) || !szame(szam));
	printf("Konvertlt eredmny: %d\n", toi(szam)); }