/* ZH.C: Karakterlnc buherls. */

#define MAX 20				/* A karakterlnc max. hossza. */
#include <stdio.h>
#include <ctype.h>
#include <string.h>

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */
int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

void main(void){
	char sor[MAX+2],		/* Input puffer. */
		 maxsor[MAX+1];		/* A leghosszabb sor. */
	int hsz,				/* Az aktulis sor hossza. */
		db=0,				/* A karakterlncok darabszma. */
		max=0,				/* A leghosszabb sor hossza. */
		i, j, palindroma;	/* Munka vltozk. */
	double atlag=0.;		/* sszeg az tlag-szmtshoz. */

	printf("\nKarakterlnc buherls:\n");
	while(printf("\nJhet a karakterlnc: "), hsz=getline(sor, MAX+1)){
		if(hsz>MAX)
			printf("A lnc legfeljebb %d karakterbl llhat!\n", MAX);
		else {
			for(i=0; sor[i]!=0&&isalpha(sor[i]); ++i);
			if(i!=hsz) printf("A karakterlnc csak betkbl llhat!\n");
			else {
				printf("A karakterlnc hossza: %5d\n", hsz);
				atlag+=hsz;
				++db;
				if(hsz>max) { max=hsz; strcpy(maxsor, sor); }
				for(i=0, j=hsz-1, palindroma=1; palindroma&&i<j; ++i, --j)
					if(sor[i]!=sor[j]) palindroma=0;
				printf("A karakterlnc%spalindroma.\n",
						palindroma?" ":" nem "); } } }
	if(db) printf("Az tlagos karakterlnc-hossz:    %5.2f\n", atlag/db);
	if(max) printf("A leghosszabb lnc %2d karakteres: %s\n", max, maxsor); }