/*------------------------------------------
//            Megszerkeszthetoe
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int megszerkeszthetoe(int aoldal, int boldal, int coldal) {
    if(aoldal+boldal>coldal && aoldal+coldal>boldal && boldal+coldal>aoldal && aoldal>0 && boldal>0 && coldal>0)
        return 1;
    else
        return 0;
}

void main(void) {
    char tmp[5+1];
    double terulet, s;
    int kerulet, vege=0, a, b, c;

    clrscr ();

    printf("Haromszog Terulet-kerulet meghatarozo program:\n"
           "==============================================\n"
           "Kerem adja meg az 'a' oldalt:\n"
           "-----------------------------\n");
    do {
        if (!getline(tmp, 5)){
            printf("Ures sor. A program kilep.\n");
            getch();
            exit(0);
        } else if(strlen(tmp) > 4) {
            printf("Max. 4 karaktert adhat meg\n");
        } else if(!egesz(tmp)) {
            printf("Nem egesz szamot adott meg!\n");
        } else {
            a=atoi(tmp);
            if(a < 1)
                printf("Az oldal hossza minimum 1 legyen!\n");
            else
                vege=1;
        }
    } while (!vege);
    vege=0;

    printf("Kerem adja meg a 'b' oldalt:\n"
           "----------------------------\n");
    do {
        if (!getline(tmp, 5)){
            printf("Ures sor. A program kilep.\n");
            getch();
            exit(0);
        } else if(strlen(tmp) > 4) {
            printf("Max. 4 karaktert adhat meg\n");
        } else if(!egesz(tmp)) {
            printf("Nem egesz szamot adott meg!\n");
        } else {
            b=atoi(tmp);
            if(b < 1)
                printf("Az oldal hossza minimum 1 legyen!\n");
            else
                vege=1;
        }
    } while (!vege);
    vege=0;

    printf("Kerem adja meg a 'c' oldalt:\n"
           "----------------------------\n");
    do {
        if (!getline(tmp, 5)){
            printf("Ures sor. A program kilep.\n");
            getch();
            exit(0);
        } else if(strlen(tmp) > 4) {
            printf("Max. 4 karaktert adhat meg\n");
        } else if(!egesz(tmp)) {
            printf("Nem egesz szamot adott meg!\n");
        } else {
            c=atoi(tmp);
            if(c < 1)
                printf("Az oldal hossza minimum 1 legyen!\n");
            else
                vege=1;
        }
    } while (!vege);

    if (megszerkeszthetoe(a, b, c)) {
        kerulet=a+b+c;
        s=(double)(a+b+c)/2;
        terulet=sqrt(s*(s-a)*(s-b)*(s-c));

        printf("    - AZ EREDMENY -\n"
               "-------------------------\n"
               "A haromszog kerulete: %d\n"
               "A haromszog terulet : %f\n", kerulet, terulet);
    } else {
        printf("A haromszog a megadott adatok alapjan nem megszerkesztheto!\n");
    }
    getch();
}