/*------------------------------------------
//                 Arukod
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

enum {KODHOSSZ = 6};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main (void) {
    char tmp[KODHOSSZ+2];
    int i,osszeg=0,vege=0;

    clrscr ();

    printf("Arukod vizsgalo program. Kerem adjon meg 6 egesz szamot:\n"
           "========================================================\n");
    do {
        if (!getline(tmp, KODHOSSZ+1))
            printf("Nem adhat meg ures sort!\n");
        else if(strlen(tmp) < KODHOSSZ)
            printf("Az arukodnak minimum %d karakterbol kell allnia!\n", KODHOSSZ);
        else if(strlen(tmp) > KODHOSSZ)
            printf("Az arukod maximum %d karakterbol allhat!\n", KODHOSSZ);
        else if(!egesz(tmp))
            printf("Csak egesz szamokat adhat meg!\n");
        else {
            for(i=0;i<5;i++) {
                osszeg+=tmp[i]-'0';
            }
            vege=1;
        }
    } while (!vege);

    printf("\nKarakteresen kiiratva : %s\n"
           "Az elso 5 szam osszege: %d\n"
           "------------------------------\n", tmp, osszeg);

    if(osszeg%6 == tmp[5]-'0')
        printf("%dmod6=%c -> A(z) %s arukod ervenyes!\n",osszeg, tmp[5], tmp);
    else
        printf("%dmod6!=%c -> A(z) %s arukod ervenytelen!\n", osszeg, tmp[5], tmp);

    getch ();
}