/*------------------------------------------
//        30 hosszu osszeado
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>

enum {MAXHOSSZ=30};

int MODegesz(char s[]){
    int i=0;
    while(s[i]){
        if(!isdigit(s[i]))
            return 0;
        i++;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int melyiknagyobb(char sz1[], char sz2[]){
    int i;
    if(strlen(sz1) > strlen(sz2))
        return 1;
    else if(strlen(sz2) > strlen(sz1))
        return 0;
    else {
        for(i=0; sz1[i]==sz2[i]; i++);
        return sz1[i]-sz2[i];
    }
}

void main(void){
    int i, vege=0, ok=0, tovabb=0;
    char szam1[MAXHOSSZ+2], szam2[MAXHOSSZ+2];

    clrscr();

    do {
        printf("Kerem adja meg az elso szamot:\n"
               "(pozitiv, nem kezdodhet nullaval es max. %d karakter):\n"
               "------------------------------------------------------\n", MAXHOSSZ);
        do {
            if (!getline(szam1, MAXHOSSZ+1))
                ok=1;
            else if (strlen(szam1) > MAXHOSSZ)
                printf("Maximum %d hosszu karaktersorozatot adhat meg!\n", MAXHOSSZ);
            else if (szam1[0]=='-')
                printf("Nem lehet negativ szamot megadni!\n");
            else if (szam1[0]=='0')
                printf("A szam elejen nem allhat nulla!\n");
            else {
                if (!MODegesz(szam1))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    ok=1;
                    tovabb=1;
                }
            }
        } while(!ok);

        if (tovabb == 1) {
            ok=0;
            printf("Kerem adja meg a masodik szamot:\n"
                   "(pozitiv, nem kezdodhet nullaval es max. %d karakter):\n"
                   "------------------------------------------------------\n", MAXHOSSZ);
            do {
                if (!getline(szam2, MAXHOSSZ+1))
                    ok=1;
                else if(strlen(szam2) > MAXHOSSZ)
                    printf("Maximum %d hosszu karaktersorozatot adhat meg!\n", MAXHOSSZ);
                else if(szam2[0]=='-')
                    printf("Nem lehet negativ szamot megadni!\n");
                else if(szam2[0]=='0')
                    printf("A szam elejen nem allhat nulla!\n");
                else {
                    if (!MODegesz(szam2))
                        printf("Nem egesz szamot adott meg!\n");
                    else {
                        ok=1;
                        vege=1;
                    }
                }
            } while (!ok);
        }
    } while (!vege);

    printf("\n\nAz elso megadott szam:\n"
           "----------------------\n"
           "%s\n\n"
           "A masodik megadott szam:\n"
           "------------------------\n"
           "%s\n\n", szam1, szam2);

    if (!strcmp(szam1, szam2))
        printf("A ket szam megegyezik!\n");
    else if (melyiknagyobb(szam1, szam2) > 0)
        printf("A elso szam nagyobb mint a masodik!\n");
    else
        printf("A masodik szam nagyobb mint az elso!\n");

    getch();
}