/*
 * Description : 30 hosszu osszeado
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.23
 */
#include <stdio.h>
#include <ctype.h>
#include <conio.h>

enum {
    MAXHOSSZ=30
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int melyiknagyobb(char sz1[], char sz2[]) {
    int i;

    if(strlen(sz1) > strlen(sz2))
        return 1;
    if(strlen(sz1) < strlen(sz2))
        return -1;
    for(i=0; sz1[i]==sz2[i]; i++);
        return sz1[i]-sz2[i];
}

int egesz(char s[]) {
    int i=0;

    for (i=0; s[i]; ++i)
        if (!isdigit(s[i]))
            return 0;
    return 1;
}

void main(void) {
    char szam1[MAXHOSSZ+2], szam2[MAXHOSSZ+2];
    int vege=0, ok;

    clrscr();

    do {
        ok=0;
        printf("Kerem adja meg az elso szamot:\n"
               "(pozitiv, nem kezdodhet nullaval es max. %d karakter):\n"
               "------------------------------------------------------\n", MAXHOSSZ);
        do {
            if (!getline(szam1, MAXHOSSZ+1))
                vege=1;
            else if (strlen(szam1) > MAXHOSSZ)
                printf("Maximum %d hosszu karaktersorozatot adhat meg!\n", MAXHOSSZ);
            else if (szam1[0]=='-')
                printf("Nem lehet negativ szamot megadni!\n");
            else if (szam1[0]=='0')
                printf("A szam elejen nem allhat nulla!\n");
            else {
                if (!egesz(szam1))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    ok=1;
                }
            }
        } while(!ok && !vege);

        if (!vege) {
            ok=0;
            printf("Kerem adja meg a masodik szamot:\n"
                   "(pozitiv, nem kezdodhet nullaval es max. %d karakter):\n"
                   "------------------------------------------------------\n", MAXHOSSZ);
            do {
                if (!getline(szam2, MAXHOSSZ+1))
                    vege=1;
                else if(strlen(szam2) > MAXHOSSZ)
                    printf("Maximum %d hosszu karaktersorozatot adhat meg!\n", MAXHOSSZ);
                else if(szam2[0]=='-')
                    printf("Nem lehet negativ szamot megadni!\n");
                else if(szam2[0]=='0')
                    printf("A szam elejen nem allhat nulla!\n");
                else {
                    if (!egesz(szam2))
                        printf("Nem egesz szamot adott meg!\n");
                    else {
                        ok=1;

                        printf("\n\nAz elso megadott szam:\n"
                               "----------------------\n"
                               "%s\n\n"
                               "A masodik megadott szam:\n"
                               "------------------------\n"
                               "%s\n\n", szam1, szam2);

                        if (!strcmp(szam1, szam2))
                            printf("A ket szam megegyezik!\n");
                        else if (melyiknagyobb(szam1, szam2) > 0)
                            printf("A elso szam nagyobb mint a masodik!\n");
                        else
                            printf("A masodik szam nagyobb mint az elso!\n");
                    }
                }
            } while (!ok && !vege);
        }
    } while (!vege);

    printf("Uros sort utott a program kilep.\n");

    getch();
}