/*
 * Description : Primtenyezok
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.24
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int oszto(int n) {
    int i;

    for (i=2; i<n/2; ++i)
        if (n%i == 0)
            return i;
}

void main(void){
    int k=0,i=0,j=0,ok=0,bekert=0,primoszto=2,osztok[30],osztandok[30];
    char tmp[3+1];

    clrscr();

    printf("Kerem adjon meg egy egesz szamot (min. -9999 max. 9999):\n"
           "--------------------------------------------------------\n");

    /* egesz szam bekerese -9999 es 9999 kozott ures sorig */
    do {
        printf("Kerem adja meg a(z) %d. szamot: ", bekert+1);
        if (!getline(tmp, 6)) {
            printf("Ures sort utott, vege a bekeresnek!\n\n");
            ok=1;
        } else if (strlen(tmp) > 5)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if(!egesz(tmp))
            printf("Egesz szamot kell megadni!\n");
        else {
            osztandok[bekert]=atoi(tmp);

            if(osztandok[bekert] < -9999)
                printf("Legalabb -9999 -et kell megadni!\n");
            else if(osztandok[bekert] > 9999)
                printf("Maximum 9999 -et adjon meg!\n");
            else
                ++bekert;
        }
    } while (!ok);

    /* primtenyezokre bontas es kiiratas */
    for (i=0; i<bekert; ++i) {
        printf("%-5d legkisebb osztoja: %d\n"
               "Primtenyezos felbontasa: ", osztandok[i], oszto(osztandok[i]));

        if (osztandok[i] < 0)
            osztandok[i] *= -1;

        /* primtenyezos felbontas */
        do {
            if (osztandok[i] % primoszto == 0) {
                osztandok[i] /= primoszto;
                osztok[j] = primoszto;
                ++j;
            } else {
                ++primoszto;
            }
        } while (osztandok[i] > 1);

        /* a primtenyezok kiiratasa */
        for (k=0; k<j; ++k) {
            printf("%d", osztok[k]);

            if (osztok[k] == osztok[k+1] && k!=j-1)
                printf("^");
            else if (k!=j-1)
                printf("*");
        }

        printf("\n--------------------------------------\n\n");

        for (k=0; k<j; ++k)
            osztok[j]=0;

        j=0; k=0; primoszto=2;
    }
    getch();
}