/*------------------------------------------
//                Hazszamos
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

enum {MAXHOSSZ=50};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int haznyira(int a, int b) {
    return (a>b)?((a-b)/2):((b-a)/2);
}

void main(void){
    char tmp[MAXHOSSZ+2];
    int i, ok=0, hazszam1=0, hazszam2=0, rossz1, rossz2, rosszhazszam, szamdb=0;

    clrscr();

    printf("Kerem adja meg a lakcimet:\n"
           "--------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert lehet megadni!\n", MAXHOSSZ);
        else if (tmp[strlen(tmp)-1]!='.')
            printf("A lakcimet '.' karakterrel kell lezarni!\n");
        else {
            rossz1=0;
            rossz2=0;
            rosszhazszam=0;
            szamdb=0;

            for (i=0; !isspace(tmp[i]); i++)
                if (!isalpha(tmp[i]))
                    rossz1 = 1;

            while(isspace(tmp[i]))
                i++;

            for (i=i; !isspace(tmp[i]); i++)
                if (!isalpha(tmp[i]))
                    rossz2 = 1;

            while (isspace(tmp[i]))
                i++;

            for (i=i; i<strlen(tmp)-1; i++) {
                if (!isdigit(tmp[i]))
                    rosszhazszam=1;
                else
                    szamdb++;
            }

            if(rossz1==0 && rossz2==0 && rosszhazszam==0 && szamdb<4)
                ok=1;

            if(rossz1!=0 || rossz2!=0)
                printf("Az utcanev nincs megfeleloen megadva!\n");

            if(rosszhazszam!=0)
                printf("A hazszam nincs megfeleloen megadva!\n");

            if (szamdb>3)
                printf("A hazszam csak 3 szamjegybol allhat!\n");
        }
    } while (!ok);

    for(i=strlen(tmp)-(szamdb+1); i<strlen(tmp)-1; i++)
        hazszam1+=(tmp[i]-'0')*pow(10, --szamdb);

    ok=0;
    printf("\nA megadott cim: %s\n\n", tmp);
    printf("Kerem adja meg a barat hazszamat:\n"
           "---------------------------------\n");
    do {
        if(!getline(tmp, 4))
            printf("Nem lehet ures sort megadni!\n");
        else if(strlen(tmp) > 4)
            printf("A hazszam maximum 3 karakterbol allhat!\n");
        else if(!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            hazszam2=atoi(tmp);
            if(hazszam1%2 != hazszam2%2)
                printf("A baratoknak azonos oldalon kell lakniuk!\n");
            else
                ok=1;
        }
    } while (!ok);

    printf("A baratok %d haznyira laknak egymastol.\n", haznyira(hazszam1, hazszam2));

    getch();
}