/*
 * Description : Hazszamos
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.24
 */
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

enum {
    MAXHOSSZ=50
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int haznyira(int a, int b) {
    return (a>b)?((a-b)/2):((b-a)/2);
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int i,ok=0,hazszam1=0,hazszam2=0,rossz,szamdb;

    clrscr();

    printf("Kerem adja meg a lakcimet:\n"
           "--------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert lehet megadni!\n", MAXHOSSZ);
        else if (tmp[strlen(tmp)-1]!='.')
            printf("A lakcimet '.' karakterrel kell lezarni!\n");
        else {
            szamdb=0;
            rossz=0;

            for (i=0; !isspace(tmp[i]) && tmp[i]!='.'; ++i)
                if (!isalpha(tmp[i]))
                    rossz=1;
            if (rossz) {
                printf("Az utcanev elso tagja nincs megfeleloen megadva!\n");
            } else {
                while(isspace(tmp[i]) && tmp[i]!='.')
                    ++i;

                for (; !isspace(tmp[i]) && tmp[i]!='.'; ++i)
                    if (!isalpha(tmp[i]))
                        rossz=1;

                if (rossz) {
                    printf("Az utcanev masodik nincs megfeleloen megadva!\n");
                } else {
                    while (isspace(tmp[i]) && tmp[i]!='.')
                        ++i;

                    for (; i<strlen(tmp)-1; ++i) {
                        if (!isdigit(tmp[i]))
                            rossz=1;
                        else
                            ++szamdb;
                    }

                    if(rossz)
                        printf("A hazszam csak szamokat tartalmazhat!\n");
                    else if (szamdb<1)
                        printf("A hazszam minimum 1 szamjegybol alljon!\n");
                    else if (szamdb>3)
                        printf("A hazszam maximum 3 szamjegybol allhat!\n");
                    else
                        ok=1;
                }
            }
        }
    } while(!ok);

    printf("\nA megadott cim: %s\n\n", tmp);
    printf("Kerem adja meg a barat hazszamat:\n"
           "---------------------------------\n");

    for (i=strlen(tmp)-(szamdb+1); i<strlen(tmp)-1; ++i)
        hazszam1+=(tmp[i]-'0')*pow(10, --szamdb);

    ok=0;
    do {
        if (!getline(tmp, 4))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 3)
            printf("A hazszam maximum 3 karakterbol allhat!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            hazszam2=atoi(tmp);

            if (hazszam1%2 != hazszam2%2)
                printf("A baratoknak azonos oldalon kell lakniuk!\n");
            else
                ok=1;
        }
    } while (!ok);

    printf("A baratok %d haznyira laknak egymastol.\n", haznyira(hazszam1, hazszam2));

    getch();
}