/*------------------------------------------
//                   Bin
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <math.h>

enum {MAXHOSSZ=16};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int bin(char s[]) {
    int i;

    for(i=0; i<strlen(s); i++) {
        if(s[i]!='0' && s[i]!='1')
            return 0;
    }
    return 1;
}

int egyesszamlalo(char s[]) {
    int db=0, i;

    for(i=0; i<strlen(s); i++) {
        if(s[i]=='1')
            db++;
    }
    return db;
}

unsigned int btou(char s[]) {
    int eredmeny=0, i;
    char tmp[17];

    /* a cim szerinti parameter atadas miatt kell a tombot atmasolni*/
    strcpy(tmp, s);
    tmp[17] = '\0';

    strrev(tmp);
    for(i = strlen(tmp) - 1; i>=0; i--)
        if(tmp[i]=='1')
            eredmeny+=(int)pow(2, i);

    return eredmeny;
}

void main (void) {
    char tmp[MAXHOSSZ+2];
    int szamdb=0;

    clrscr();

    printf("Kerem adjon meg max. 16db max. %d szamjegyu bin szamot:\n", MAXHOSSZ);
    do {
        printf("\nKerem adja meg a(z) %d. szamot:\n"
               "-------------------------------\n", szamdb+1);
        if(!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sort utott, a program kilep.\n");
            getch();
            exit(0);
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d hosszu karaktersort adhat meg!\n", MAXHOSSZ);
        else {
            if(!bin(tmp))
                printf("Nem binaris szamot adott meg!\n");
            else {
                printf("A szamban %d db 1-es van, azaz ", egyesszamlalo(tmp));
                if (egyesszamlalo(tmp)%2 == 0)
                    printf("paros darabszamu.\n");
                else
                    printf("paratlan darabszamu.\n");
                printf("A(z) %s szam tizes szamrendszerben: %u\n", tmp, btou(tmp));
                szamdb++;
            }
        }
    } while(szamdb < 16);

    getch();
}