/*------------------------------------------
//             Stringfordito
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAXHOSSZ 20
#define MINHOSSZ 5

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void){
    int i,j;
    char tmp[MAXHOSSZ+2], eredmeny[MAXHOSSZ+2];

    clrscr();

    do {
        printf("Kerem adjon meg egy karatersorozatot (min. %d max. %d):\n"
               "-------------------------------------------------------\n", MINHOSSZ, MAXHOSSZ);
        if (!getline(tmp,MAXHOSSZ + 1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if(strlen(tmp) < MINHOSSZ)
            printf("Minimum %d hosszu karakterlancot kell megadnia!\n\n", MINHOSSZ);
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d hosszu karatersorzatot adhat meg!\n\n", MAXHOSSZ);
        else {
            printf("\nAz eredetileg bekert karatersor: %s\n\n", tmp);
            for(j=0; j<strlen(tmp); j++) {
                eredmeny[0]=tmp[strlen(tmp)-1];

                for(i=1; i<strlen(tmp); i++)
                    eredmeny[i]=tmp[i-1];

                eredmeny[i]='\0';
                printf("A(z) %0.2d. karaktercsere: %s\n", j+1, eredmeny);
                strcpy(tmp, eredmeny);
            }
            printf("\n");
        }
    } while (1);
}