/*------------------------------------------
//              Futoverseny
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MAXHOSSZ 4

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void){
    int eNevezett, hNevezett, noiNevezett, teljesitNo, teljesitFerfi, vege=0;
    char tmp[MAXHOSSZ + 2];

    clrscr();

    printf("Kerem adja meg az elore nevezettek szamat:\n"
           "------------------------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ + 1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            eNevezett = atoi(tmp);
            if (eNevezett < 0)
                printf("Nem adhat meg negativ szamot!\n");
            else
                vege = 1;
        }
    } while (!vege);

    vege=0;
    printf("Kerem adja meg a helyben nevezettek szamat:\n"
           "-------------------------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ + 1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            hNevezett = atoi(tmp);
            if (hNevezett < 0)
                printf("Nem adhat meg negativ szamot!\n");
            else
                vege = 1;
        }
    } while (!vege);

    vege=0;
    printf("Kerem adja meg a noi nevezok szamat:\n"
           "------------------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ + 1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            noiNevezett = atoi(tmp);
            if (noiNevezett > eNevezett + hNevezett)
                printf("Maximum %d no nevezhetett a versenyre!\n", eNevezett + hNevezett);
            else if (noiNevezett < 0)
                printf("Nem adhat meg negativ szamot!\n");
            else
                vege = 1;
        }
    } while (!vege);

    vege=0;
    printf("Kerem adja meg a versenyt teljesito nok szamat:\n"
           "-----------------------------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ + 1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Tul hosszu karaktersorozatot adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            teljesitNo = atoi(tmp);
            if(teljesitNo > noiNevezett)
                printf("Maximum %d no teljesitheti a versenyt!\n", noiNevezett);
            else if (teljesitNo < 0)
                printf("Nem adhat meg negativ szamot!\n");
            else
                vege = 1;
        }
    } while (!vege);

    if (noiNevezett < eNevezett+hNevezett) {
        vege=0;
        printf("Kerem adja meg a versenyt teljesito ferfiak szamat:\n"
               "---------------------------------------------------\n");
        do {
            if (!getline(tmp, MAXHOSSZ + 1))
                printf("Nem lehet ures sort megadni!\n");
            else if (strlen(tmp) > MAXHOSSZ)
                printf("Tul hosszu karaktersorozatot adott meg!\n");
            else if (!egesz(tmp))
                printf("Nem egesz szamot adott meg!\n");
            else {
                teljesitFerfi = atoi(tmp);
                if (teljesitFerfi > (eNevezett + hNevezett) - noiNevezett)
                    printf("Maximum %d ferfi teljesitheti a versenyt!\n", (eNevezett + hNevezett) - noiNevezett);
                else if (teljesitFerfi < 0)
                    printf("Nem adhat meg negativ szamot!\n");
                else
                    vege = 1;
            }
        } while (!vege);
    } else {
        teljesitFerfi = 0;
    }

    printf("Az elore nevezettek szama: %d\n", eNevezett);
    printf("Az helyszinen nevezettek szama: %d\n", hNevezett);
    printf("A noi nevezettek szama: %d\n", noiNevezett);
    printf("A versenyt teljesito noi nevezettek szama: %d\n", teljesitNo);
    printf("A versenyt teljesito ferfi nevezettek szama: %d\n", teljesitFerfi);

    getch();
}
