/*------------------------------------------
//           Karakterosztalyzo
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MINHOSSZ 10
#define MAXHOSSZ 20

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void){
    int i, db=1, osszhossz=0, szam, betu, egyeb;
    char tmp[MAXHOSSZ + 2];

    clrscr();

    printf("Kerem adjon meg egy min. %d max, %d hosszusagu karaterlancot:\n"
           "-------------------------------------------------------------\n", MINHOSSZ, MAXHOSSZ);
    do {
        if (!getline(tmp, MAXHOSSZ + 1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) < MINHOSSZ)
            printf("Minimum %d karaktert kell megadnia!\n", MINHOSSZ);
        else if(strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karatert adhat meg!\n", MAXHOSSZ);
        else {
            szam  = 0;
            betu  = 0;
            egyeb = 0;
            osszhossz += strlen(tmp);

            for(i=0; i<strlen(tmp); i++){
                if(isdigit(tmp[i]))
                    szam++;
                else if(isalpha(tmp[i]))
                    betu++;
                else
                    egyeb++;
            }

            printf("\nA megadott karakterlanc: %s\n\n", tmp);

            printf("Adatai savdiagrammal:\n"
                   "---------------------\n"
                   "szamok: %2.d db: ", szam);

            for (i=0; i<szam; i++)
                printf("*");

            printf("\nbetuk : %2.d db: ", betu);
            for (i=0; i<betu; i++)
                printf("*");

            printf("\negyeb : %2.d db: ", egyeb);
            for (i=0; i<egyeb; i++)
                printf("*");

            printf("\n\nCsak a szamokat megjelenitve:\n"
                   "-----------------------------\n");
            for (i=0; i<strlen(tmp); i++)
                if(isdigit(tmp[i]))
                    printf("%c", tmp[i]);

            printf("\n\nA karaterlancok hossza atlagosan %.2f karakter.\n\n", (float)osszhossz/db);
            db++;
        }
    } while (1);
}