/*
 * Description : Jogositvany
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>

enum {
    EVHOSSZ=4,
    MINEVSZAM=1950,
    MAXEVSZAM=2010
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int jogsikat(char s[]) {
    char *kategoriak[]={"A1","A","B","C1","C","D1","D","BE","C1E","CE","D1E","DE"};
    int i;

    for (i=0; i<12; ++i)
        if (!strcmp(kategoriak[i], s))
            return 1;

    return 0;
}

void main(void) {
    char tmp[EVHOSSZ+2];
    int ok=0, evszam, maxevszam;

    clrscr();

    printf("Kerem adja meg az aktualis evet (max. %d):\n"
           "-------------------------------------------\n", MAXEVSZAM);
    do {
        if(!getline(tmp, EVHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) != EVHOSSZ)
            printf("A megadott evszamnak %d szamjegybol kell allnia!\n", EVHOSSZ);
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg evnek!\n");
        else {
            maxevszam = atoi(tmp);

            if (maxevszam < MINEVSZAM)
                printf("A legkisebb evszam %d lehet.\n", MINEVSZAM);
            else if (maxevszam > MAXEVSZAM)
                printf("A legnagyobb evszam %d lehet.\n", MAXEVSZAM);
            else
                ok=1;
        }
    } while (!ok);

    printf("Kerem adja meg a jogositvany kiadasi evet (4 egesz szam):\n"
           "---------------------------------------------------------\n");
    ok=0;
    do {
        if(!getline(tmp, EVHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) != EVHOSSZ)
            printf("A megadott evszamnak %d szamjegybol kell allnia!\n", EVHOSSZ);
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg evnek!\n");
        else {
            evszam = atoi(tmp);
            if (evszam < MINEVSZAM)
                printf("A legkisebb evszam %d lehet.\n", MINEVSZAM);
            else if (evszam > maxevszam)
                printf("A legnagyobb evszam %d lehet.\n", maxevszam);
            else
                ok=1;
        }
    } while (!ok);

    ok=0;
    printf("Kerem adja meg a jogositvany kategoriajat:\n"
           "------------------------------------------\n");
    do {
        if(!getline(tmp, 4))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > 3)
            printf("A leghosszabb kategoria max. 3 karakteres lehet!\n");
        else if (!jogsikat(tmp))
            printf("A(z) %s tipusu jogositvany nem talalhato.\n", tmp);
        else
            ok=1;
    } while (!ok);

    printf("-----------------------------------------------\n"
           "A(z) %s tipusu jogositvany kiadasi datuma %d.\n"
           "-----------------------------------------------\n", tmp, evszam);
    getch();
}