/*------------------------------------------
//              Nevbeolvaso
//               by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <conio.h>

#define MINHOSSZ 10
#define MAXHOSSZ 120

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int nevellenorzo(char nev[]) {
    int i;

    if (!isupper(nev[0])) {
        printf("A vezeteknev nem nagybetuvel kezdodik!\n");
        return 0;
    }

    if (!islower(nev[1])) {
        printf("A vezeteknev nem kisbetuvel folytatodik!\n");
        return 0;
    }

    for (i=2; nev[i]!='\0'; ++i) {
        if (!isalpha(nev[i]) && !isspace(nev[i])) {
            printf("A nev nem megfelelo karaktert is tartalmaz!\n");
            return 0;
        }
    }

    for (i=3; islower(nev[i]); ++i);

    if (!isspace(nev[i])) {
        printf("A nevek nem space karakterrel vannak elvalasztva!\n");
        return 0;
    }

    for (; isspace(nev[i]); ++i);

    if (!isupper(nev[i])) {
        printf("A keresztnev nem nagybetuvel kezdodik!\n");
        return 0;
    }

    if (!islower(nev[i+1])) {
        printf("A keresztnev nem kisbetuvel folytatodik!\n");
        return 0;
    }

    return 1;
}

void tukoriras(char nev[]) {
    int i;

    for (i=2; !isspace(nev[i]); ++i);

    for (--i; i>=0; --i)
        printf("%c", nev[i]);
    printf(" ");

    for (i=strlen(nev)-1; !isspace(nev[i]); --i)
        printf("%c", nev[i]);
}

void angolformatum(char nev[]) {
    int i;

    for (i=3; !isspace(nev[i]); ++i);

    for (++i; nev[i]!='\0'; ++i)
        printf("%c", nev[i]);
    printf(" ");

    for (i=0; !isspace(nev[i]); ++i)
        printf("%c", nev[i]);
}

int main(void) {
    char nev[MAXHOSSZ+2];
    int ok=0, i;

    clrscr();

    printf("Kerem adjon meg egy min. %d hosszu magyar szemlynevet\n"
           "------------------------------------------------------\n", MINHOSSZ);
    do {
        if (!getline(nev, MAXHOSSZ+1))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(nev) < MINHOSSZ)
            printf("A nev minimum %d hosszu legyen!\n", MINHOSSZ);
        else if (strlen(nev) > MAXHOSSZ)
            printf("A nev maximum %d hosszu legyen!\n", MAXHOSSZ);
        else
            if(nevellenorzo(nev))
                ok=1;
    } while (!ok);

    printf("A monogram\n"
           "------------\n");
    for (i=0; nev[i]!='\0'; ++i) {
        if (isupper(nev[i]))
            printf("%c. ", nev[i]);
    }
    printf("\n\n");

    printf("Tukorirassal\n"
           "------------\n");
    tukoriras(nev);
    printf("\n\n");

    printf("Angolul\n"
           "------------\n");
    angolformatum(nev);
    printf("\n\n");

    getch();
}