/*
 * Description : Bringa edzes
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.28
 */
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

enum {
    MIDZONA=31,
    MAXZONA=46,
    MINSEBESSEG=15,
    MAXSEBESSEG=60,
    MAXSEBESSEGDB=20,
    MAXSZAMHOSSZ=2,
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    char tmp[MAXSZAMHOSSZ+2];
    int sebessegek[MAXSEBESSEGDB], vege=0, bekert=0, min, minindex=0, max, maxindex=0, i, osszeg=0;
    int zonak[] = {0, 0, 0};
    double atlag;

    clrscr();

    do {
        printf("Kerem adja meg a %d. sebesseget:\n", bekert+1);

        if (!getline(tmp, MAXSZAMHOSSZ+2)) {
            printf("Ures sort utott, vege a bekeresnek.\n\n");
            vege=1;
        } else if (strlen(tmp) > MAXSZAMHOSSZ)
            printf("A sebessegertek maximum %d karakterbol allhat!\n", MAXSZAMHOSSZ);
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            sebessegek[bekert] = atoi(tmp);

            if (sebessegek[bekert] < MINSEBESSEG)
                printf("Minimum %dkm/h sebesseget adjon meg.\n", MINSEBESSEG);
            else if (sebessegek[bekert] > MAXSEBESSEG)
                printf("Maximum %dkm/h sebesseget adjon meg.\n", MAXSEBESSEG);
            else {
                if (sebessegek[bekert] >= MAXZONA)
                    ++zonak[2];
                else if (sebessegek[bekert] >= MIDZONA)
                    ++zonak[1];
                else
                    ++zonak[0];

                ++bekert;
            }
        }
    } while(bekert<MAXSEBESSEGDB && !vege);

    if (bekert!=0) {
        min=max=sebessegek[0];

        for(i=0; i<bekert; ++i) {
            osszeg += sebessegek[i];

            if (sebessegek[i] < min) {
                min = sebessegek[i];
                minindex = i;
            }

            if (sebessegek[i] > max) {
                max = sebessegek[i];
                maxindex = i;
            }
        }

        atlag = (double)osszeg/bekert;

        printf("A legalacsonyabb sebesseg a %d. ertek %d km/h\n"
               "A legmagassabb sebesseg a %d. ertek %d km/h\n", minindex+1, min, maxindex+1, max);

        printf("Az atlagsebesseg %.2f km/h volt.\n", atlag);

        printf("Minimumnal %.2f km/h -val nagyobb.\n"
               "Maximumnal %.2f km/h -val kissebb.\n", atlag-MINSEBESSEG, MAXSEBESSEG-atlag);

        if (max == MAXSEBESSEG)
            printf("Elertuk a max sebesseget.\n");
        else
            printf("Nem ertuk el a max. sebessget, %d km/h kellett volna.\n", MAXSEBESSEG-max);

        printf("MAX ZONA: %d perc.\n"
               "MID ZONA: %d perc.\n"
               "LOW ZONA: %d perc.\n", zonak[2], zonak[1], zonak[0]);
    } else {
        printf("Egy adatot sem adtak meg!\n");
    }

    getch();
}