/*
 * Description : Szamfordito
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>

enum {
    SZAMJEGYEK=5
};

int getline(char s[],int lim){
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int joszam(char szam[]) {
    int i;

    for (i=0; szam[i]; ++i)
        if (!isdigit(szam[i]))
            return 0;
    return 1;
}

int szamjegyosszeg(char szamjegyek[]) {
    int i, osszeg=0;

    for (i=0; szamjegyek[i]; ++i)
        osszeg+=szamjegyek[i]-'0';

    return osszeg;
}


void main(void) {
    char tmp[SZAMJEGYEK+2];
    long int szam, forditott_szam;
    int ok, vege=0, osszeg=0, i;

    clrscr();

    do {
        printf("Kerem adjon meg egy %d jegyu egesz szamot:\n", SZAMJEGYEK);
        ok=0;
        do {
            if (!getline(tmp, SZAMJEGYEK+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) != SZAMJEGYEK)
                printf("A szam %d szamjegybol alljon.\n", SZAMJEGYEK);
            else if (!joszam(tmp))
                printf("A szam csak szamjegyekbol allhat!\n");
            else {
                ok=1;

                osszeg+=tmp[0]-'0';
                printf("%c", tmp[0]);

                for (i=1; tmp[i]; ++i) {
                    printf(" + %c", tmp[i]);
                    osszeg+=tmp[i]-'0';
                }

                printf(" = %d\n\n", osszeg);

                szam = atol(tmp);
                strrev(tmp);
                forditott_szam = atol(tmp);

                printf("A megadott %ld szam ", szam);

                if (szam%2==0)
                    printf("paros.\n");
                else
                    printf("paratlan.\n");

                printf("A megadott %ld szam", forditott_szam);

                if (forditott_szam%2==0)
                    printf("paros.\n");
                else
                    printf("paratlan.\n");

                printf("%ld + %ld = %ld\n\n", szam, forditott_szam, szam + forditott_szam);
            }
        } while(!ok);
    } while(!vege);

    getch();
 }