/*------------------------------------------
//           Neptunkod generator
//                by -zolee-
//
//  Hat szambol es/vagy betubol allo neptun-
//  kod generalasa fuggvennyel is megoldva
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void NKgenerator(int darabszam) {
    int i,k;

    for(k=0; k<darabszam; k++) {
        printf("%2d. Neptunkod: ", k+1);
        for(i=0; i<6; i++){
            if(rand()%2 == 0)
                printf("%c", rand()%26 + 'A');
            else
                printf("%d", rand()%10);
        }
        printf("\n");
    }
}


void main (void) {
    int i, k, vege=0, darabszam=0;
    char tmp[7+1];

    clrscr();
    randomize();

    printf("Neptunkod generalo program.\n"
           "---------------------------\n"
           "Kerem adja meg, hogy hany neptunkodot generaljunk (1-99):\n");

    do {
        if (!getline(tmp, 3))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(tmp)>2)
            printf("Tul sok karaktert adott meg!\n");
        else {
            if (!egesz(tmp))
                printf("Nem egesz szamot adott meg!\n");
            else {
                darabszam=atoi(tmp);
                if (darabszam < 1)
                    printf("Legalabb egyet adjon meg!\n");
                else
                    vege=1;
            }
        }
    } while (!vege);

    printf("Fuggvennyel kiiratva:\n"
           "---------------------\n");
    NKgenerator(darabszam);

    printf("\nFuggveny nelkul kiirva:\n"
           "-----------------------\n");
    for(k=0; k<darabszam; k++) {
        printf("%2d. Neptunkod: ",k+1);
        for(i=0; i<6; i++) {
            if (rand()%2 == 0)
                printf("%c",rand()%26+'A');
            else
                printf("%d",rand()%10);
        }
        printf("\n");
    }

    getch();
}