#include<stdio.h>

#define MAXK 128
#define MAXT 15

int getline(char s[], int lim) 
{
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int binarise(char s[])
{
	int i=0;
	
	while(s[i]!='\0')
	{
		if(s[i]!='0' && s[i]!='1')
			return 0;
		i++;
	}
	return 1;
}

void main(void)
{
	int i, log, jo, tocsadb, maxtocsa, szaraz, hossz;
	char tmp[MAXK+2];
	
	printf("A program egy karakterlancot var a szabvanybemeneten\n"
		"ami csak nullakbol es egyesekbol allhat, es maximum %d db nulla\n"
		"kovetheti egymast! Ures sorra vagy EOF-ra a program kilep!\n"
		"-------------------------------------------------------------------\n", MAXT);

	log=0;
	
	while(!log)
	{
		jo=szaraz=1;
		maxtocsa=tocsadb=i=0;
		
		printf("\nKerem adja meg az osveny felepiteset: \n");
		
		if(!(hossz=getline(tmp,128+1)))
		{
			printf("Ures sort vagy EOF-ot adott meg! A program kilep!\n"
				"A kilepeshez nyomjon meg egy billentyut!\n");
			log=1;
			getchar();
		}
		else if(hossz>MAXK)
			printf("Maximum %d db karaktert adhat meg soronkent!\n", MAXK);
		else
		{
			if(binarise(tmp))
			{
				while(tmp[i]!='\0' && jo==1)
				{
					if(tocsadb>MAXT)
					{
						printf("Hibas az osvany, mert maximum %d db tocsa kovetheti egymast!\n"
							"-------------------------------------------------------------------\n\n", MAXT);
						jo=0;
					}
					else
					{
					 	if(tmp[i]=='0')
						{
							tocsadb++;
							
							if(tocsadb>maxtocsa)
								maxtocsa=tocsadb;
							
							if(tocsadb>4)
								szaraz=0;
						}
						else
						{
							tocsadb=0;
						}
					}
					i++;
				}
				
				if(jo==1)
				{
					printf("A tocsa grafikus kepe:\n"
						"<");
					
					for(i=0;i<hossz;i++)
					{
						if(tmp[i]=='0')
							printf("_");
						else
							printf("x");
					}
					
					printf(">\n\n"
						"A leghosszabb tocsanak a hossza: %d\n", maxtocsa);
					
					if(szaraz==1)
						printf("A turazo at tud ugy kellni az osvenyen, hogy nem lep tocsaba!\n"
							"-------------------------------------------------------------------\n");
					else
						printf("A turazonak muszaj a tocsaba lepnie ahhoz, hogy atkeljen az osvenyen!\n"
							"-------------------------------------------------------------------\n");
				}
			}
			else
				printf("Az osveny csak nullakbol es egysekbol allhat!\n");

		}		
	}	
}
