#include <stdio.h>
#define MAX 10
#define LIMIT 12
#define PMIN 140
#define PMAX 198

int getline(char s[],int lim)
{
	int i;
	char c;
	for(i=0;i<lim && (c=getchar())!=EOF && c!='\n';i++)
	{	s[i]=c; }
	/* feltetel: amig i < lim, a c (amibe elotte beolvastunk egy kar-t) nem EOF es nem enter */
	s[i]='\0';
	/* bill. puffer */
	while(c!=EOF && c!='\n')
		c=getchar();
	return i; /* karakterlanc hossza */
}

#define HSZ sizeof(int)/sizeof(short)*5  /* 5 v 10 jegyu PMAX az int meretetol fuggoen */
int egesze(char s[])
{
  int i=0;
  int kezd;

  /* feher karakterek atlepese */
  while (s[i]==' ' || s[i]=='\n' || s[i]=='\t')
    i++;
  if (s[i]=='+' || s[i]=='-')
    i++;
  kezd=i;

  while (s[i]>='0' && s[i]<='9' && i-kezd<HSZ)
    ++i;

  if (s[i]!=0 && s[i]!='\n' && s[i]!='\t' && s[i]!=' ')
    return 0;
  else
    return 1;
}

void main(void)
{
	int i=0;
	int tmp=0;
	int atlag=0;
	int min=0;
	int minhely=0;
	int max=0;
	int maxhely=0;
	int zoneone=0;
	int zonetwo=0;
	int zonethree=0;
	
	char sor[PMAX+1];
	int pulzus[LIMIT];
	
	printf("Kerem a meresi adatokat(%d es %d kozott):\n",PMIN,PMAX);
	printf("%d meres: ",i+1);
	while(i<LIMIT && getline(sor,PMAX))
	{
		tmp=atoi(sor);
		if(egesze(sor)==1 && PMIN<=tmp && tmp<=PMAX)
		{
			pulzus[i]=tmp;
			i++;
		}
		else
		{
			printf("A megadott ertek helytelen! Kerem ujra:\n");
		}

		if(i<12)
			printf("%d meres: ",i+1);
	}
	
	printf("\n");

	for(i=0;i<LIMIT;i++)
	{
		atlag=atlag+pulzus[i];
	}	
	atlag=atlag/12;
	printf("Az atlag pulzus: %d\n",atlag);

	min=pulzus[0];
	max=pulzus[0];
	for(i=0;i<LIMIT;i++)
	{
		if(pulzus[i]<min)
		{
			min=pulzus[i];
			minhely=i;
		}
	}

	for(i=0;i<LIMIT;i++)
	{
		if(pulzus[i]>max)
		{
			max=pulzus[i];
			maxhely=i;
		}
	}
	printf("Min: %d, meres: %d, Max: %d, meres: %d\n",min,minhely+1,max,maxhely+1);

	printf("A min. (%d) es max. (%d) pulzusertek kozotti elteres idoben: ",min,max);
	if(minhely+1 > maxhely+1)
		printf("%d a minimalisan mert ertek elott.\n",((minhely+1)*5)-((maxhely+1)*5));
	else
		printf("%d a minimalisan mert ertek utan.\n",((maxhely+1)*5)-((minhely+1)*5));


	printf("Elteres az atlag es a min. ertek kozott: %d\n",atlag-min);
	printf("Elteres az atlag es a max. ertek kozott: %d\n",max-atlag);
	if(max==PMAX)
		printf("A legmagasabb mert pulzusertek elerte a maximalis-terheleskori erteket!");
	else
		printf("Maximalis terheleskori mert pulzusertek: %d, elteres a maximalistol: %d, Nem erte el a maximalis erteket.\n",max,PMAX-max);

	for(i=0;i<LIMIT;i++)
	{
		if(pulzus[i]<=170 && 140<=pulzus[i])
			zoneone++;
		if(pulzus[i]<=185 && 171<=pulzus[i])
			zonetwo++;
		if(pulzus[i]<=198 && 186<=pulzus[i])
			zonethree++;
	}
	
	printf("Meresi zonak:\n");
	printf("140-170: %d\n",zoneone);
	printf("171-185: %d\n",zonetwo);
	printf("186-198: %d\n",zonethree);
}
