/* 09_5.C: Legfeljebb 36-os alap szmok konverzija. Fejlesztett
		   vltozat: a ctype.h makrinak felhasznlsval. */

#include <stdio.h>
#include <ctype.h>
#define MAX 128		/* Input puffer mrete. */

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */

int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

int ell36(char[], int);
long toi36(char[], int);

void main(void){
	int alap=1;
	char be[MAX+1];

	while(printf("Szmrendszer alapja: "), getline(be, MAX)>0){
		if(!ell36(be, 10) || (alap=(int)toi36(be, 10))<2 || alap>36)
			printf("A szmrendszer alapja 2 s 36 kztt lehet!\n");
		else
			while(printf("Adja meg az tvltand szmot: "),
				  getline(be, MAX)>0)
				if(ell36(be, alap))
					printf("Konvertlva: %ld\n", toi36(be, alap));
				else printf("Formailag hibs %d alap szm.\n",alap); } }

/* "Az s karakterlnc a alap szm-e?" krdsre ad logikai vlaszt
   a fggvny. */
int ell36(char s[], int a){
	int i;

	if(a<=10)
		for(i=0; s[i]>='0' && s[i]<a+'0'; ++i);
	else
		for(i=0; isdigit(s[i]) || tolower(s[i])>='a' &&
				 tolower(s[i])<'a'+a-10; ++i);
	if(s[i]) return 0;
    else return 1; }

/* Az s karakterlncot a alap szmnak tekintve long-g konvertlja
   s ez a rutin visszaadott rtke. */
long toi36(char s[], int a){
	int i;
	long n=0l;

	if(a<=10)
		for(i=0; s[i]>='0'&&s[i]<a+'0'; ++i) n=a*n+s[i]-'0';
	else
		for(i=0; isdigit(s[i]) || tolower(s[i])>='a' &&
				 tolower(s[i])<a+'a'-10; ++i)
			if(isdigit(s[i])) n=n*a+s[i]-'0';
			else n=n*a+tolower(s[i])-'a'+10;
    return n; }