/* 11_3.C: Vals szmok tlaga, minimuma, maximuma s rendezse. */
#include <stdio.h>
#include <stdlib.h>

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */
int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

/* A fggvny logikai vlaszt ad arra a krdsre, hogy paramtere
   formailag helyes egsz-e karakterlnc alakban. */
#define HSZ sizeof(int)/sizeof(short)*5 /* Az int max. jegyeinek szma. */
int egesze(char s[]){
	int i = 0;		/* Indexels. */
	int kezd;		/* Az els numerikus karakter indexe. */
	/* A karakterlnc elejn lev fehr karakterek tlpse: */
	while(s[i] == ' ' || s[i] == '\n' || s[i] == '\t') ++i;
	/* Az eljel tlpse: */
	if( s[i] == '+' || s[i] == '-') ++i;
	kezd = i;		/* A szmjegyek itt kezddnek. */
	/* Elrelps a kvetkez, els nem numerikus karakterre: */
	while( s[i] >= '0' && s[i] <= '9' && i - kezd < HSZ) ++i;
	/* Dnts: */
	if(kezd==i || s[i]!='\n'&&s[i]!='\t'&&s[i]!=' '&&s[i]!=0) return 0;
	else return 1; }

#include <ctype.h>
int lebege(char s[]){	/* Az s karakterlnc lebegpontos numerikus-e? */
	int i=0, kezd;
	/* A karakterlnc elejn lev fehr karakterek tlpse. */
	while(isspace(s[i]))++i;
	/* Az eljel elintzse. */
	if(s[i]=='+'||s[i]=='-')++i;
	kezd=i;
	/* Az egsz rsz intzse. */
	while(isdigit(s[i]))++i;
	if(s[i]=='.')++i;
	/* A trt rsz. */
	while(isdigit(s[i]))++i;
	if(i==kezd||kezd+1==i&&s[kezd]=='.')return 0;
	/* Kitev rsz. */
	if(s[i]=='E'||s[i]=='e'){
		++i;
		if(s[i]=='+'||s[i]=='-')++i;
		if(!isdigit(s[i]))return 0;
		while(isdigit(s[i]))++i;}
	if(s[i])return(0);
	else return(1); }

void rendez(double w[],int n){	/* Az n elem w vals tmb nvekv */
	int i,j,m;					/* rendezse. */
	double cs;
	for(i=0;i<n-1;++i){
		for(j=i+1, m=i; j<n; ++j)
			if(w[j]<w[m]) m=j;
		if(i!=m){ cs=w[i]; w[i]=w[m]; w[m]=cs;} } }

#define MAX 100
#define INP 20

void main(void){
	int n=0;                /* Rendezend elemek szma. */
	char sor[INP+1];        /* Input puffer. */
	double v[MAX];          /* A szmokat trol tmb. */
	double min, max;        /* Minimum, maximum. */
	long double atlag=0.0l; /* sszeg */
	int i;
	while(n<1||n>MAX){
		printf("\nHny vals szmot rendezznk(1-%d)? ",MAX);
		getline(sor,5);
		if(egesze(sor)) n=atoi(sor);}
	printf("\n\nKrem a rendezend vals szmokat!\n");
	for(i=0;i<n;++i){
		printf("%5d: ",i+1);
		if(getline(sor,INP)>0 && lebege(sor)) v[i]=atof(sor);
		else --i; }
	min=max=v[0];
	for(i=0;i<n;atlag=atlag+v[i],++i)
		if(v[i]<min) min=v[i];
		else if(v[i]>max) max=v[i];
	printf("\nA szmsorozat\tminimuma %10.2f\n\t\tmaximuma %10.2f\n",min, max);
	printf("\t\ttlaga %12.2Lf\n",atlag/n);
	printf("\nA rendezett szmok:\n");
	rendez(v,n);
	for(i=0;i<n;i++)printf("%10.2f",v[i]); }