/*------------------------------------------
//             Atlag-paritas
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

enum {SZAMDARAB = 5};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    int szamok[SZAMDARAB];
    int i,joszamok=0,paros=0,paratlan=0,parosdarab=0,paratlandarab=0;
    char temp[6+1];

    clrscr ();

    printf("Szam bekeres es atlag szamitas! Adjon %d szamot:\n"
           "================================================\n", SZAMDARAB);
    do {
        printf("Kerem adja meg a(z) %d. szamot:\n"
               "-------------------------------\n", joszamok+1);
        if (!getline(temp, 6))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(temp) > 5)
            printf("Tul sok karaktert adott meg!\n");
        else if (!egesz(temp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            szamok[joszamok]=atoi(temp);
            if (szamok[joszamok] < 1)
                printf("Pozitiv szamot adjon meg!\n");
            else
                joszamok++;
        }
    } while (joszamok < SZAMDARAB);

    printf("Tartalma:\n"
           "---------\n");
    for (i=0; i<SZAMDARAB; i++) {
        printf("%d,", szamok[i]);

        if (szamok[i]%2 == 0){
            parosdarab++;
            paros+=szamok[i];}
        else {
            paratlandarab++;
            paratlan+=szamok[i];
        }
    }

    printf("\n%d db paros szam atlaga: %.2f", parosdarab, (double)paros/parosdarab);
    printf("\n%d db paratlan szam atlaga: %.2f", paratlandarab, (double)paratlan/paratlandarab);

    getch();
}