/*------------------------------------------
//         Oszthato harommal
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define MAXHOSSZ 5
#define MAXSZAMDB 30

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void){
    char tmp[MAXHOSSZ+2];
    int i, szamdb=0;
    long int aktszam;

    clrscr();

    printf("Kerem adjon meg max %d otjegyu egesz szamot melyek oszthatoak harommal:\n"
           "----------------------------------------------------------------------\n", MAXSZAMDB);
    do {
        if(!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) != MAXHOSSZ)
            printf("Egy %d karakterbol allo szamot kell megadni!\n", MAXHOSSZ);
        else if(!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            aktszam=atol(tmp);
            if(aktszam%3 != 0)
                printf("A(z) %.ld nem oszthato harommal maradek nelkul!\n", aktszam);
            else {
                printf("A(z) %.ld oszthato harommal.\n", aktszam);
                szamdb++;
            }
        }
    } while (szamdb < MAXSZAMDB);

    printf("Bekertunk %d darab megfelelo szamot, a program kilep.\n", MAXSZAMDB);
    getch();
}