/*
 * Description : Oszthato harommmal
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <stdlib.h>

enum {
    HOSSZ=5,
    MAXSZAMDB=30
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    char tmp[HOSSZ+2];
    int szamdb=0;
    long int aktszam;

    clrscr();

    printf("Kerem adjon meg max %d otjegyu egesz szamot melyek oszthatoak harommal:\n"
           "----------------------------------------------------------------------\n", MAXSZAMDB);
    do {
        if(!getline(tmp, HOSSZ+1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) != HOSSZ)
            printf("Egy %d karakterbol allo szamot kell megadni!\n", HOSSZ);
        else if(!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            aktszam=atol(tmp);

            if(aktszam%3==0) {
                printf("A(z) %.ld oszthato harommal.\n", aktszam);
                ++szamdb;
            } else
                printf("A(z) %.ld nem oszthato harommal maradek nelkul!\n", aktszam);
        }
    } while(szamdb < MAXSZAMDB);

    printf("Bekertunk %d darab megfelelo szamot, a program kilep.\n", MAXSZAMDB);

    getch();
}