/*------------------------------------------
//             Szamszamlalo
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/

#include <stdio.h>
#include <ctype.h>

#define MAXHOSSZ 30

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void){
    char tmp[MAXHOSSZ+2];
    int i, ok=0, szamdb=0;

    clrscr();

    printf("Kerem adjon meg egy karaktersorozatot (max. 30 elem):\n"
           "-----------------------------------------------------\n");
    do {
        if(!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert lehet megadni!\n", MAXHOSSZ);
        else {
            printf("A megadott karaktersorozat: %s\n", tmp);

            for(i=0; i<strlen(tmp); i++)
                if(isdigit(tmp[i]))
                    szamdb++;

            if(szamdb == 0)
                printf("A begepelt karakterek kozott nem volt szam!\n");
            else
                printf("A begepelt karaktersorozat %d db szamot tartalmazott!\n", szamdb);

            ok=1;
        }
    } while (!ok);

    getch();
}