/*------------------------------------------
//             Lakcimvizsgalo
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lakcim(char s[]){
    int rosszut, rosszszam, rosszterulet, i, j;

    if(!isdigit(s[0]) || !isdigit(s[1]) || !isdigit(s[2]) || !isdigit(s[3])) {
        printf("Az iranyitoszam csak egesz szamokbol allhat!\n");
        return 0;
    } else if (s[4] != ',') {
        printf("Az iranyitoszam elvalaszto \',\' karaktere rossz helyen van!\n");
        return 0;
    } else if (s[strlen(s)-1] != '.') {
        printf("A lakcimet a \'.\' karaterrel kell lezarni!\n");
        return 0;
    } else {
        rosszut=0;
        rosszszam=0;
        rosszterulet=0;

        for (i=5; isspace(s[i]); i++);

        for (j=i; !isspace(s[j]); j++)
            if (!isalpha(s[j]))
                rosszut=1;

        for (i=j; isspace(s[i]); i++);

        for (j=i; !isspace(s[j]); j++)
            if (!isalpha(s[j]))
                rosszut=1;

        for (i=j; isspace(s[i]); i++);

        for (j=i; !isspace(s[j]); j++)
            if(!isalpha(s[j]))
                rosszterulet=1;

        for(i=j; isspace(s[i]); i++);

        for(j=i; s[j]!='.'; j++)
            if(!isdigit(s[j]))
                rosszszam=1;

        if(rosszut)
            printf("A kozteruletnev csak betukbol es feher karakterekbol allhat!\n");

        if(rosszszam)
            printf("A hazszam csak szamokbol allhat!\n");

        if(rosszterulet)
            printf("A kozterulet nincs megadva megfeleloen!\n");
    }

    if(rosszszam==1 || rosszut==1 || rosszterulet==1)
        return 0;
    else
        return 1;
}


void main(void){
    char tmp[50+2];
    int i, j, ok=0;

    clrscr();

    printf("Kerem adja meg a lakcimet:\n"
           "--------------------------\n");
    do {
        if(!getline(tmp, 51))
            printf("Nem lehet ures sort megadni!\n");
        else
            ok=lakcim(tmp);
    } while (!ok);

    printf("A megadott lakcim:\n"
           "------------------\n"
           "%s\n", tmp);

    getch();
}