/*
 * Description : Stringfordito
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>

enum {
    MINHOSSZ=5,
    MAXHOSSZ=20
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    int i, j;
    char tmp[MAXHOSSZ+2], c;

    clrscr();

    do {
        printf("Kerem adjon meg egy karatersorozatot (min. %d max. %d):\n"
               "-------------------------------------------------------\n", MINHOSSZ, MAXHOSSZ);
        if (!getline(tmp, MAXHOSSZ + 1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if(strlen(tmp) < MINHOSSZ)
            printf("Minimum %d hosszu karakterlancot kell megadnia!\n\n", MINHOSSZ);
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d hosszu karatersorzatot adhat meg!\n\n", MAXHOSSZ);
        else {
            printf("\nAz eredetileg bekert karatersor: %s\n\n", tmp);

            for(i=0; tmp[i]; ++i) {
                /* utolso karakter menetese */
                c = tmp[strlen(tmp)-1];
                /* mindegyik karaktert egyel jobbra masolunk */
                for (j=strlen(tmp)-1; j>=1; --j)
                    tmp[j] = tmp[j-1];
                /* az elso karakter felulirasa az utolsoval */
                tmp[0] = c;
                
                printf("A(z) %0.2d. karaktercsere: %s\n", i+1, tmp);
            }
            printf("\n");
        }
    } while (1);
}