/*------------------------------------------
//                Muveletes
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lebege(char s[]){
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

float muvelet(char jel, float szam1, float szam2){
    if(jel == '+')
        return szam1 + szam2;
    if(jel == '-')
        return szam1 - szam2;
    if(jel == '*')
        return szam1 * szam2;
    if(jel == '/')
        return szam1 / szam2;
}

void main(void) {
    int i, ok, minIndex, maxIndex, muveletek=0;
    char tmp[8+2], jelek[255];
    float elso[255], masodik[255], eredmenyek[255];

    clrscr();

    printf("Muveletvegzo program. Kerem kovesse az utasitasokat:\n"
           "====================================================\n");

    do {
        printf("Kerem adja meg az elso szamot(ures sorra a program kilep)\n"
               "---------------------------------------------------------\n");
        ok = 0;
        do {
            if (!getline(tmp, 8+1)) {
                printf("Ures sort utott, a program kilep!\n");
                for(i = 0; i<muveletek; i++){
                    printf("A(z) %d. muvelet: %.4f %c %.4f = %.4f\n", i+1, elso[i], jelek[i], masodik[i], eredmenyek[i]);
                }
                getch();
                exit(0);
            } else if (strlen(tmp)>8)
                printf("Tul sok karaktert adott meg!\n");
            else if(!lebege(tmp))
                printf("Nem lebegopontos szamot adott meg!\n");
            else {
                elso[muveletek] = atof(tmp);

                if(elso[muveletek] < -1000)
                    printf("Minimum -1000 kell megadnia!\n");
                else if(elso[muveletek] > 1000)
                    printf("Maximum 1000 -et adhat meg!\n");
                else
                    ok = 1;
            }
        } while (!ok);

        printf("Kerem adja meg a muveleti jelet (+, -, *, /)\n"
               "--------------------------------------------\n");
        ok = 0;
        do {
            if(!getline(tmp, 2))
                printf("Nem adhat meg ures sort!\n");
            else if(strlen(tmp)>1)
                printf("Csak egy muveleti jelet adhat meg!");
            else {
                if(tmp[0]!='+' && tmp[0]!='-' && tmp[0]!='*' && tmp[0]!='/')
                    printf("Nem megfelelo muveleti jelet adott meg!\n");
                else {
                    jelek[muveletek] = tmp[0];
                    ok = 1;
                }
            }
        } while (!ok);

        printf("Kerem adja meg a masodik szamot\n"
               "-------------------------------\n");
        ok = 0;
        do {
            if(!getline(tmp, 8+1))
                printf("Nem adhat meg ures sort!\n");
            else if(strlen(tmp) > 8)
                printf("Tul sok karaktert adott meg!");
            else if(!lebege(tmp))
                printf("Nem lebegopontos szamot adott meg!\n");
            else {
                masodik[muveletek] = atoi(tmp);

                if(masodik[muveletek] < -1000)
                    printf("Minimum -1000 kell megadnia!\n");
                else if(masodik[muveletek] > 1000)
                    printf("Maximum 1000 -et adhat meg!\n");
                else
                ok = 1;
            }
        } while (!ok);

        printf("A muvelet: : %.4f %c %.4f = %.4f\n\n", elso[muveletek], jelek[muveletek], masodik[muveletek], (eredmenyek[muveletek] = muvelet(jelek[muveletek], elso[muveletek], masodik[muveletek])));
        muveletek++;
    } while(1);
}