/*------------------------------------------
//                Ellenorzo
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.jpg
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MAXHOSSZ 30

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int nevell(char s[]){
    int space=0, i;

    if(!isupper(s[0]) || !isalpha(s[1]))
        return 1;

    for(i=0; i<strlen(s); i++){
        if(isspace(s[i]))
            space++;
    }

    if(space == 0)
        return 1;
    
    i = 0;
    while (isalpha(s[i])) i++;
    while (isspace(s[i])) i++;

    if(!isupper(s[i]) || !isalpha(s[i + 1]))
        return 1;
    else
        return 0;
}

int szigell(char s[]){
    int i, szamjegy=0, betu=0;

    for(i=0; i<strlen(s); i++) {
        if(isalpha(s[i]))
            betu++;

        if(isdigit(s[i]))
            szamjegy++;

        s[i] = toupper(s[i]);
    }

    if(szamjegy != 6 || betu != 2)
        return 1;
    else
        return 0;
}

void main(void){
    char tmp[MAXHOSSZ + 2];

    clrscr();
 
    do {
        printf("Kerem adjon meg egy nevet:\n"
               "--------------------------\n");
        if (!getline(tmp, MAXHOSSZ)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (!nevell(tmp))
            printf("A megadott %s nev helyes.\n", tmp);
        else
            printf("A megadott %s nev nem helyes.\n", tmp);

        printf("Kerem adja meg a nevhez tartozo szemelyigazolvanyszamot:\n"
               "--------------------------------------------------------\n");
        if(!getline(tmp, 9)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if(strlen(tmp) > 8)
            printf("A szemelyigazolvanyszam max. 8 karakterbol allhat!\n");
        else if(!szigell(tmp))
            printf("A megadott %s szemelyigazolvany szam helyes.\n", tmp);
        else
            printf("A megadott %s szemelyigazolvany szam nem helyes.\n",tmp);
    } while (1);
}