/*------------------------------------------
//             Stringfordito
//                by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define MINHOSSZ 10

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void){
    int i, j, elvalaszto;
    char tmp[127], tmp2[128], eredmeny[128], kbetuk[] = "NEKHNOHHNK";

    clrscr();

    printf("Kerem adjon meg egy min. %d hosszusagu karaterlancot:\n"
           "=====================================================\n", MINHOSSZ);
    do {
        if (!getline(tmp, 126)){
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) < MINHOSSZ)
            printf("Minimum %d karaktert kell megadnia!\n", MINHOSSZ);
        else {
            elvalaszto = 0;

            printf("Az eredeti karaktersorozat: %s\n"
                   "---------------------------\n\n", tmp);

            for(i=0; i<strlen(tmp); i++) {
                if(isdigit(tmp[i]))
                    tmp[i] = kbetuk[tmp[i] - '0'];

                if (tmp[i] == ' ')
                    elvalaszto++;
            }
            
            if ((strlen(tmp) - elvalaszto) < 10 && elvalaszto > 0) {
                printf("A 'space' karaktereket 'hashmark' jelre csereljuk.\n\n");
                for(i=0; i<strlen(tmp); i++)
                    if(tmp[i] == ' ')
                        tmp[i] = '#';
            } else if (elvalaszto > 0) {
                printf("A 'space' karaktereket kivesszuk.\n\n");
                j = 0;
                strcpy(tmp2, tmp);

                for(i=0; i<strlen(tmp2); i++){
                    if(tmp2[i] != ' '){
                        tmp[j] = tmp2[i];
                        j++;
                    }
                }
                tmp[j] = '\0';
            } else
                printf("A szovegben nem volt'space' karakter.\n\n");

            j = strlen(tmp) - 5;
            for (i=0; i<5; i++){
                eredmeny[i] = tmp[j];
                j++;
            }

            for (i=5; i<strlen(tmp)-5; i++)
                eredmeny[i] = tmp[i];

            for (j=0; j<5; j++) {
                eredmeny[i] = tmp[j];
                i++;
            }
            eredmeny[i] = '\0';

            printf("Az modositott karaktersorozat: %s\n"
                   "------------------------------\n\n", eredmeny);

            printf("Az utolso ot memoriacim: ");

            for(i = strlen(eredmeny) - 5; i < strlen(eredmeny); i++)
                printf("%p   ", &eredmeny[i]);
            printf("\n");
        }
    } while (1);
}