/*------------------------------------------
//              Szamkereso
//              by -zolee-
//
//  A feladat leirasat lasd a !Feladat!.txt
//  fajlban.
------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define MAXHOSSZ 125

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int szamkeres(char sor[]) {
    int i, j, szam, temp;
    char tmp[127];

    for (i=0; sor[i]!='\0'; ++i) {
        if (isdigit(sor[i])) {
            for (j=i; isdigit(sor[j]); ++j)
                tmp[j-i] = sor[j];
            tmp[j-i]='\0';

            if (strlen(tmp) >= 4) {
                tmp[4] = '\0';
                temp = atoi(tmp);
                if (temp > szam)
                    szam = temp;
            }
            i=j;
        }
    }
    return szam;
}

int szamszamlalo(char sor[]) {
    int i, szamdb=0;
    for (i=0; sor[i]!='\0'; ++i)
        if (sor[i]=='1' && sor[i+1]=='2' && sor[i+2]=='3')
            ++szamdb;
    return szamdb;
}

void main(void) {
    char tmp[MAXHOSSZ+2], maxsor[MAXHOSSZ+2];
    int szam, max=0, sorozatdb=0, negyjegyuszamok=0, osszeg=0;

    clrscr();
    printf("Kerem adja meg a karaktersorozatot, max %d karakter:\n", MAXHOSSZ);

    do {
        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("A legnagyobb szam a(z) %d volt, mely a \"%s\" sorban talalhato.\n", max, maxsor);
            printf("A megadott sorokban az 123 sorozat %d alkalomal szerepelt!\n", sorozatdb);
            printf("A megadott %d darab negyjegyu szam atlaga %.2f.\n", negyjegyuszamok, osszeg/(double)negyjegyuszamok);
            getch();
            exit(0);
        } else {
            sorozatdb += szamszamlalo(tmp);
            if ((szam=szamkeres(tmp))==0) {
                printf("Nem volt megfelelo szam!\n");
            } else {
                printf("%d a bevitt szam, es 4-el valo osztasnal a maradek %d.\n", szam, szam%4);
                if (szam > max) {
                    max = szam;
                    strcpy(maxsor, tmp);
                }
                osszeg+=szam;
                ++negyjegyuszamok;
            }
        }
    } while (1);

    getch();
}